<template>
  <div class="modal-container" id="optConfirmModal">
    <div class="modal-header">
      <p class="title">{{ $t('otp.confirmModal.title')}}</p>
      <button type="button" @click="closeModal()" class="btn-close"><span aria-hidden="true">×</span></button>
    </div>
    <div class="modal-body">
      <div class="form-group">
        <input name="code" 
          v-validate="'required|length:6'"
          @keyup.enter="verifyCode"
          data-vv-as="OTP code"
          type="text"
          @focus="resetError"
          maxlength="6"
          @keypress="isNumber"
          @keyup="handleEventKeyUp"
          v-model="code"
          ref="otpCode"
          data-vv-validate-on="none"
          :placeholder="$t('otp.removeOtp.placeholder.cofirm_code')"
        >
        <span class="invalid-feedback" v-if="errors.has('code')">
          {{ errors.first('code') }}
        </span>
      </div>
      <div class="text-center">
        <button type="button" class="btn btn-submit" @click="verifyCode">{{ $t('common.modal.btn.submit') }}</button>
      </div>
    </div>
  </div>
</template>
<script>
import OtpInputMixin from '../../../common/components/Otp/OtpInputMixin';

export default {
  props: {
    modalData: {
      type: Object,
      required: true,
    }
  },
  data () {
    return {
      code: '',
    };
  },
  mixins: [OtpInputMixin],
  methods: {
    closeModal () {
      this.$broadcast('close-modal');
    },
    verifyCode () {
      this.$validator.validateAll()
        .then(() => {
          if (this.errors.any()) {
            return;
          }
          if (!this.loading) {
            this.loading = true;
            this.modalData.callback(Object.assign({code: this.code}, this.modalData.params))
              .then(res => {
                this.loading = false;
                this.closeModal();
                this.$broadcast(`${this.modalData.key}-confirm-otp-successful`, res);
              })
              .catch((error) => {
                this.errors.clear();
                this.loading = false;
                const errors = error.errors;
                Object.keys(errors).forEach((key) => {
                  this.errors.add({
                    field: key,
                    msg: errors[key][0]
                  });
                });
                if (!this.errors.has('code')) {
                  this.closeModal();
                  this.$broadcast(`${this.modalData.key}-callback-has-errors`, errors);
                }
              });
          }
        })
    },
  },
  mounted () {
    this.$refs.otpCode.focus();
  },
};
</script>
<style lang="scss" scoped>
  @import '../../../../sass/mobile/typoVariables';
  * {
    font-family: $font-family-home;
  }
  #optConfirmModal {
    width: 270rem;
    height: 245rem;
    border-radius: 10px;
    background: $bg_primary;
    box-shadow: 0 2px 40px 0 rgba(0, 0, 0, 0.18);
    margin: auto;
    .modal-header {
      padding: 0;
      border: none;
      position: relative;
      .title {
        font-size: 16rem;
        font-weight: bold;
        color: #1c1c1c;
        text-align: center;
        line-height: 3.13;
        padding: 31rem 0 5rem;
      }
      .btn-close {
        width: 20rem;
        height: 20rem;
        background-color: #ffffff;
        border: 1px solid #fff;
        border-radius: 50%;
        position: absolute;
        outline: none;
        top: 10rem;
        right: 10px;
        span {
          cursor: pointer;
          color: #989898;
          font-size: 11rem;
        }
      }
    }
    .modal-body {
      margin: 0;
      padding: 0 20rem;
      .form-group {
        text-align: center;
        background: none;
        position: relative;
        padding: 0;
        width: 100%;
        input {
          width: 100%;
          height: 40rem;
          border-radius: 74rem;
          background-color: #ffffff;
          border: none;
          font-size: 14rem;
          padding: 0 20rem;
          outline: none;
          &:placeholder {
            color: #cacaca;
          }
        }
      }
      .btn-submit {
        margin-top: 30rem;
        width: 90rem;
        height: 32rem;
        border-radius: 30rem;
        border: solid 1px #fa7300;
        background: #fff;
        font-size: 12rem;
        font-weight: bold;
        font-style: normal;
        font-stretch: normal;
        line-height: normal;
        letter-spacing: 0.5px;
        color: #fa7300;
        outline: none;
        cursor: pointer;
      }
    }

    .invalid-feedback {
      color: red;
      position: absolute;
      text-align: left;
      bottom: -20rem;
      font-size: 11rem;
    }
  }
</style>
